
// Note: see usbdi.h in the DDK for the USBD_STATUS source definitions
typedef unsigned long USBD_STATUS;
#define USBD_STATUS(Status) ((ULONG)(Status) & 0x0FFFFFFFL)
#define USBD_STATE(Status) ((ULONG)(Status) & 0xF0000000L)

// HC status codes (Note: both error and stall bit are set)
#define USBD_STATUS_SUCCESS                  ((USBD_STATUS)0x00000000UL)
#define USBD_STATUS_PENDING                  ((USBD_STATUS)0x40000000UL)
#define USBD_STATUS_HALTED                   ((USBD_STATUS)0xC0000000UL)
#define USBD_STATUS_ERROR                    ((USBD_STATUS)0x80000000UL)

#define USBD_STATUS_CRC                      ((USBD_STATUS)0xC0000001UL)
#define USBD_STATUS_BTSTUFF                  ((USBD_STATUS)0xC0000002UL)
#define USBD_STATUS_DATA_TOGGLE_MISMATCH     ((USBD_STATUS)0xC0000003UL)
#define USBD_STATUS_STALL_PID                ((USBD_STATUS)0xC0000004UL)
#define USBD_STATUS_DEV_NOT_RESPONDING       ((USBD_STATUS)0xC0000005UL)
#define USBD_STATUS_PID_CHECK_FAILURE        ((USBD_STATUS)0xC0000006UL)
#define USBD_STATUS_UNEXPECTED_PID           ((USBD_STATUS)0xC0000007UL)
#define USBD_STATUS_DATA_OVERRUN             ((USBD_STATUS)0xC0000008UL)
#define USBD_STATUS_DATA_UNDERRUN            ((USBD_STATUS)0xC0000009UL)
#define USBD_STATUS_RESERVED1                ((USBD_STATUS)0xC000000AUL)
#define USBD_STATUS_RESERVED2                ((USBD_STATUS)0xC000000BUL)
#define USBD_STATUS_BUFFER_OVERRUN           ((USBD_STATUS)0xC000000CUL)
#define USBD_STATUS_BUFFER_UNDERRUN          ((USBD_STATUS)0xC000000DUL)
#define USBD_STATUS_NOT_ACCESSED             ((USBD_STATUS)0xC000000FUL)
#define USBD_STATUS_FIFO                     ((USBD_STATUS)0xC0000010UL)

#define USBD_STATUS_ENDPOINT_HALTED          ((USBD_STATUS)0xC0000030UL)
#define USBD_STATUS_NO_MEMORY                ((USBD_STATUS)0x80000100UL)
#define USBD_STATUS_INVALID_URB_FUNCTION     ((USBD_STATUS)0x80000200UL)
#define USBD_STATUS_INVALID_PARAMETER        ((USBD_STATUS)0x80000300UL)
#define USBD_STATUS_ERROR_BUSY               ((USBD_STATUS)0x80000400UL)
#define USBD_STATUS_REQUEST_FAILED           ((USBD_STATUS)0x80000500UL)
#define USBD_STATUS_INVALID_PIPE_HANDLE      ((USBD_STATUS)0x80000600UL)
#define USBD_STATUS_NO_BANDWIDTH             ((USBD_STATUS)0x80000700UL)
#define USBD_STATUS_INTERNAL_HC_ERROR        ((USBD_STATUS)0x80000800UL)
#define USBD_STATUS_ERROR_SHORT_TRANSFER     ((USBD_STATUS)0x80000900UL)
#define USBD_STATUS_BAD_START_FRAME          ((USBD_STATUS)0xC0000A00UL)
#define USBD_STATUS_ISOCH_REQUEST_FAILED     ((USBD_STATUS)0xC0000B00UL)
#define USBD_STATUS_FRAME_CONTROL_OWNED      ((USBD_STATUS)0xC0000C00UL)
#define USBD_STATUS_FRAME_CONTROL_NOT_OWNED  ((USBD_STATUS)0xC0000D00UL)
#define USBD_STATUS_CANCELED                 ((USBD_STATUS)0x00010000UL)
#define USBD_STATUS_CANCELING                ((USBD_STATUS)0x00020000UL)


